'
$include "rapidq.inc"
$include "fmod3.70.inc"
dim f$ as string
dim lngStream as long
    lngStream = FSOUND_Stream_Open (wave$, FSOUND_2D, 0,0)
dim Channel as long
DIM OpenDialog AS QOPENDIALOG 
OpenDialog.Filter = "Fichiers audio|*.wav;*.mp3" 
OpenDialog.FilterIndex = 1
dim position as integer
dim posL as integer
dim vl as integer
dim vr as integer    

declare sub Dxloop
declare sub Quit
declare sub init
declare sub play
declare sub stop
declare sub openF
declare sub pause
declare sub openF

Application.ShowHint = 1
Application.HintColor = &hb5ff00

dim font as QFont
Font.Name = "Arial" 
Font.AddStyles(fsBold)
font.Color = clBlue
font.size = 12

DIM DXTimer AS QDXTimer
    DXTimer.Enabled = True
    DXTimer.Interval = 10             
    DXTimer.OnTimer = DXloop
  
CREATE Form AS QForm
    Width = 550
    Height = 220
    caption = "GG_Player"
    Center
    onClose = quit
    create ScreenX AS QDXScreen   
        Init(320, 180)            
        left = 220
        top = 2
        width = 320
        height = 180
    end create    
    create infoLabel as QLabel
        top = 20
        left = 35
        width = 50
        font = font
    end create
    create info2Label as QLabel
        top = 40
        left = 35
        width = 100
        font = font
    end create
    create info3Label as QLabel
        top = 60
        left = 35
        width = 100
        font = font
    end create
    CREATE PlayB AS QBUTTON
        Cursor = crHandPoint
        Left = 60
        Top = 100
        Height = 30
        Width = 30
        OnClick = play
        font = font
        caption = ">"
        enabled = 0
        ShowHint = 1
        hint = "Lecture"
    END CREATE
    CREATE StopB AS QBUTTON
        Cursor = crHandPoint
        Left = 120
        Top = 100
        Height = 30
        Width = 30
        font = font
        OnClick = stop
        caption = "[]"        
        enabled = 0
        ShowHint = 1
        hint = "Stop"        
    END CREATE   
    CREATE openB AS QBUTTON
        Cursor = crHandPoint
        Left = 30
        Top = 100
        Height = 30
        Width = 30
        font = font
        OnClick = openF
        caption = "^"
        ShowHint = 1
        Hint = "Ouvrir fichier"
    END CREATE
    CREATE PauseB AS QBUTTON
        Cursor = crHandPoint
        Left = 90
        Top = 100
        Height = 30
        Width = 30
        font = font
        OnClick = pause
        caption = "="
        ShowHint = 1
        hint = "Pause"
        enabled = 0
    END CREATE
    CREATE QuitB AS QBUTTON
        Cursor = crHandPoint
        Left = 150
        Top = 100
        Height = 30
        Width = 30
        font = font
        OnClick = Quit
        caption = "X"
        ShowHint = 1
        Hint = "Quitter"
    END CREATE
    CREATE POSGauge AS QGauge
        top = 150
        left = 30
        width = 150
        height = 12
        backColor = &h00ffff
        visible = 0
    END CREATE
END CREATE

Form.ShowModal
'=============================
SUB Quit
    FSOUND_Stream_Close(lngStream)
    FSOUND_Close
    Application.Terminate
END SUB
'=============================
sub init   
    FSOUND_Init(44100, 32, 0)
end sub
'=============================
sub play
    if f$="" then openF
    info2Label.caption = "Secondes :"
    DXtimer.enabled = 1
    'lngStream = FSOUND_Stream_Open (f$, FSOUND_2D, 0,0)    
    channel = FSOUND_Stream_Play (FSOUND_FREE,lngStream)
    If lngStream = 0 Then
        showmessage str$(lngStream)+ FSOUND_GetErrorString(FSOUND_GetError)
    End If   
    stopB.enabled = 1 : pauseB.enabled = 1     
end sub
'=============================
sub stop
'showmessage str$(channel)
    if FSOUND_IsPlaying(channel) <> 0 then
        FSOUND_Stream_Stop(lngStream)
        'FSOUND_Stream_Close(lngStream)
        infoLabel.caption = "stop"
        DXtimer.enabled = 0
    else
        exit sub
    end if
end sub
'=============================
SUB OpenF      
    form.repaint
    stop
    f$=""
    if OpenDialog.Execute then
        f$ = OpenDialog.FileName
        for i = len(f$) to 1 step -1
            a$ = mid$(f$,i,1)
            if a$ = "\" then exit for
            ff$ = ff$+a$  
        next
        file$ = reverse$(ff$)
        form.Caption = file$
    end if
    playB.enabled = 1
    posGauge.visible = 1
    init
    lngStream = FSOUND_Stream_Open (f$, FSOUND_2D, 0,0)
    posL = FSOUND_Stream_Getlength(lngStream)
    infoLabel.caption = str$(FSOUND_GetFrequency(4))+ "htz" 
end sub    
'=============================
sub pause
    paused = FSOUND_GetPaused(channel)
    infoLabel.caption = "en pause"
    if paused = 0 then
        FSOUND_SetPaused(channel,1)
        DXtimer.enabled = 0
        infoLabel.caption = "en pause"
    else
        FSOUND_SetPaused(channel,0)
        DXtimer.enabled = 1
        infoLabel.caption = "en lecture"
    end if
end sub
'=============================
sub DXloop
    Screenx.FillRect(0,0,320,200,0)
    DXtimer.enabled = 1
    FSOUND_GetCurrentLevels (Channel,vl,vr)
    'infoLabel.caption = "volume = "+right$(str$(int(vl/100000)),3)+"-"+right$(str$(int(vr/100000)),3)
    position = FSOUND_Stream_GetPosition(lngStream)
    PosGr = position/posL
    Time = FSOUND_Stream_GetTime(lngStream)  
    info3Label.caption = str$(int(Time/1000))'millisecondes
    posGauge.position = int(posGr*100)
    vuL=val(right$(str$(int(vl/100000)),3))/10
    vuR=val(right$(str$(int(vr/100000)),3))/10
    'screenX.circle(80+vuL,80+vuL,80-vuL,80-vuL,rgb(255-vul*3,vul*3,vul),rgb(255-vul*3,vul*3,vul)) 
    'screenX.circle(220+vuR,80+vuR,220-vuR,80-vuR,rgb(vuR*3,255-vuR*3,255-vuR),rgb(vuR*3,255-vuR*3,255-vuR)) 

    screenX.fillrect(80+vuL,80+vuL,80-vuL,80-vuL,rgb(255-vul*3,vul*3,0))
    screenX.fillrect(220+vuR,80+vuR,220-vuR,80-vuR,rgb(vuR*3,0,255-vuR*3))

    'screenX.line(160,10+(vur*2),320,10+(vur*2),1*(vur*3)) 
    'screenX.line(0,10+(vul*2),160,10+(vul*2),1*(vul*3)) 

    'screenX.fillrect(0,80+vuL,160,80-vuL,rgb(255,vul*3,0))
    'screenX.fillrect(160,80+vuR,320,80-vuR,rgb(vuR*3,0,255))        
    Screenx.Flip
end sub

