$include "rapidq.inc"
$include "fmod3.70.inc"
'-----------------
dim f$ as string
dim lngstream as long
dim lngchannel as long
dim opendialog as qopendialog 
opendialog.filter = "tout fichiers(*.mp3)|*.mp3" 
opendialog.filterindex = 1
dim position as integer
dim posl as integer
    dim vl as integer
    dim vr as integer    

declare sub timerf

declare sub quit
declare sub init
declare sub play
declare sub stop
declare sub openf
declare sub pause
declare sub openf

application.showhint = 1
application.hintcolor = &hb5ff00

dim font as qfont
font.name = "arial" 
font.addstyles(fsbold, fsitalic)
font.color = clblue
font.size = 9

dim timer1 as qtimer
timer1.ontimer = timerf
timer1.enabled = 1  
  
create form as qform
 width = 550
 height = 220
 caption = "gg_player"
 center
    create infolabel as qlabel
        top = 20
        left = 35
        width = 50
        transparent = 1
        font = font
        'color = &hff8200
    end create
    create info2label as qlabel
        top = 60
        left = 35
        width = 100
        transparent = 1
        font = font
        'color = &hff8200
    end create
        create info3label as qlabel
        top = 140
        left = 35
        width = 100
        transparent = 1
        font = font
        'color = &hff8200
    end create
    create playb as qbutton
        cursor = crhandpoint
        left = 35
        top = 100
        height = 30
        width = 30
        onclick = play
        caption = ">"
        visible = 0
        showhint = 1
        hint = "Lecture"
    end create
    create stopb as qbutton
        cursor = crhandpoint
        left = 70
        top = 100
        height = 30
        width = 30
        onclick = stop
        caption = "[]"        
        visible = 0
        showhint = 1
        hint = "Stop"        
    end create   
    create openb as qbutton
        cursor = crhandpoint
        left = 105
        top = 100
        height = 30
        width = 30
        onclick = openf
        caption = "^"
        showhint = 1
        hint = "Ouvrir media"
    end create
    create pauseb as qbutton
        cursor = crhandpoint
        left = 140
        top = 100
        height = 30
        width = 30
        onclick = pause
        caption = "="
        showhint = 1
        hint = "Pause"
        visible = 0
    end create
    create quitb as qbutton
        cursor = crhandpoint
        left = 233
        top = 100
        height = 30
        width = 30
        onclick = quit
        caption = "X"
        showhint = 1
        hint = "Quitter"
    end create
end create


form.showmodal
'=============================
sub quit
    fsound_close
    application.terminate
end sub
'=============================
sub init   
    timer1.enabled = 0
    fsound_init(44100, 32, 0)
end sub
'=============================
sub play
    if f$="" then
        openf
    end if
        init
    timer1.enabled = 1
    timer1.interval = 100
    lngstream = fsound_stream_open (f$, fsound_2d, 0,0)    
    channel = fsound_stream_play (fsound_free,lngstream)
    if lngstream = 0 then
        info3label.caption = str$(lngstream)+ fsound_geterrorstring(fsound_geterror)
    end if   
    stopb.visible = 1
    pauseb.visible = 1     
    infolabel.color=&hff8200
    infolabel.caption = str$(fsound_getfrequency(4))+ "htz"    
end sub
'=============================
sub stop
    fsound_stream_stop(lngstream)
    fsound_stream_close(lngstream)
    infolabel.caption = "stop"
end sub
'=============================
sub openf  
    timer1.enabled = 0
    fsound_stream_stop(lngstream)
    form.repaint
    if opendialog.execute then
        f$ = opendialog.filename
        for i = len(f$) to 1 step -1
            a$ = mid$(f$,i,1)
            if a$ = "\" then exit for
                ff$ = ff$+a$  
        next
        file$ = reverse$(ff$)
        info3label.caption = file$
    end if
    playb.visible = 1
end sub    
'=============================
sub pause
    paused = fsound_getpaused(channel)
    infolabel.caption = "en pause"
    if paused = 0 then
        fsound_setpaused(channel,1)
        infolabel.caption = "en lecture"
    else
        fsound_setpaused(channel,0)
        infolabel.caption = "en pause"
    end if
end sub
'=============================
sub timerf
    'dim vl as integer
    'dim vr as integer
    fsound_getcurrentlevels (lngchannel,vl,vr)
    infolabel.caption = "volume = "+right$(str$(int(vl/100000)),3)+"-"+right$(str$(int(vr/100000)),3)
    position = fsound_stream_getposition(lngstream)
    posl = fsound_stream_getlength(lngstream)
    posgr = position/posl
    time = fsound_stream_gettime(lngstream)
    
    info2label.caption = "position = " + str$(posgr*100)+"  "+str$(time/1000)'millisecondes
    vul=val(right$(str$(int(vl/100000)),3))/10
    vur=val(right$(str$(int(vr/100000)),3))/10
    form.circle(300,10,300+(vul*2),10+(vul*2),0,&h0000ff*vul)
    form.circle(450,10,450-(vur*2),10+(vur*2),0,&h0000ff*vur)    
end sub

